#include <cstdio>
#include <iostream>
#include <set>

using namespace std;

int msg[1000000], prec[1000000];

int main() {
	while (true) {
		int m, q;
		scanf("%d%d", &m, &q);
		if (m == 0 && q == 0) break;
		
		set<int> s;
		
		scanf("%d", msg);
		prec[0] = -1;
		s.insert(msg[0]);
		
		//printf("%d ", prec[0]);
		
		for (int i = 1; i < m; i++) {
			scanf("%d", msg + i);
			prec[i] = prec[i - 1];
			
			while (s.find(msg[i]) != s.end()) {
				prec[i]++;
				s.erase(msg[prec[i]]);
			}
			
			s.insert(msg[i]);
			
			//printf("%d ", prec[i]);
		}
		//printf("\n");
		
		for (int i = 0; i < q; i++) {
			int l, r;
			scanf("%d%d", &l, &r);
			l--;
			r--;
			
			if (prec[r] < l) {
				printf("OK\n");
			} else {
				printf("%d\n", msg[prec[r]]);
			}
		}
		
		printf("\n");
	}
}
